unit Unit1;

interface

uses
  Windows, messages, Classes, Controls, Forms, Registry, mmsystem,
  sysutils, AppEvnts, StdCtrls, ComCtrls, ExtCtrls, math;

type
  TForm1 = class(TForm)
    Button1: TButton;
    RadioGroup1: TRadioGroup;
    RadioGroup2: TRadioGroup;
    TrackBar1: TTrackBar;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    ApplicationEvents1: TApplicationEvents;
    RadioGroup3: TRadioGroup;
    procedure Button1Click(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ApplicationEvents1Message(var Msg: tagMSG; var Handled: Boolean);
    procedure RadioGroup3Click(Sender: TObject);
  private
    procedure VolumeWndProc(var Msg: TMessage);
    procedure WMNCHitTest(var M: TWMNCHitTest); message WM_NCHitTest;
  end;

var
  Form1: TForm1;
  tik:extended;//  
  F:extended;//      
  delta:extended;//      SampleRate    F
  data1,data2:array of word;  // 
  VolumeOldWndProc: TWndMethod;
  IniReg:TregIniFile;
  trig:boolean;
  Thr: LongWord;
  Channels,Resolution:word;  
  po1:tWaveFormatEx;
  po21,po22:wavehdr_tag;
  BytesPerSecond, SampleRate, DataBytes: LongInt;
  z1:integer; //
  siz:cardinal;
  mustrig:byte;  

implementation

{$R *.dfm}

procedure waveOutProc(hwo:HWAVEOUT; uMsg:UINT; dwInstance:DWORD; dwParam1:DWORD;dwParam2:DWORD);stdcall;
begin
 if uMsg=WOM_DONE then inc(mustrig);
end;

procedure PlayProc;
 var i:integer;
 v:extended;
begin
 siz:=sizeof(po21);
 trig:=true;
 mustrig:=2;
 tik:=0;

 while trig do begin
  v:=20000-form1.trackbar1.position*200;
  for i:=0 to high(data1) do begin
   data1[i]:=round(v*sin(tik));
   tik:=tik+DELTA;
  end;
  waveOutWrite(z1,@po21,siz);

  repeat sleep(10) until mustrig=2;
  mustrig:=0;
  
  v:=20000-form1.trackbar1.position*200;
  for i:=0 to high(data2) do begin
   data2[i]:=round(v*sin(tik));
   tik:=tik+DELTA;
  end;
  waveOutWrite(z1,@po22,siz);

  repeat sleep(10) until mustrig=1;
 end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
 if (button1.Caption='')or(button1.Caption='Play') then begin
  if RadioGroup3.ItemIndex=0 then
       button1.Caption:='Stop !'
  else button1.Caption:=' !';
  trig:=true;
  CreateThread(nil,0,@PlayProc,nil,0,Thr);
 end else begin
  trig:=false;
  if RadioGroup3.ItemIndex=0 then
       button1.Caption:='Play'
  else button1.Caption:='';
 end;
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
label2.Caption:=inttostr(100-TrackBar1.Position)+'%';
case length(label2.caption) of
 2:label2.Left:=225;
 3:label2.Left:=223;
 4:label2.Left:=220;
end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 VolumeOldWndProc:=trackbar1.WindowProc;
 trackbar1.WindowProc:=VolumeWndProc;

 Channels:=1;
 SampleRate:=44100;
 Resolution:=16;

 BytesPerSecond:=Channels*SampleRate*Resolution div 8;
 DataBytes:=3200*(Resolution div 8)*Channels;

 setlength(data1,DataBytes div (Resolution div 8));
 setlength(data2,DataBytes div (Resolution div 8));

 po1.wFormatTag:=WAVE_FORMAT_PCM;
 po1.nChannels:=Channels;
 po1.nSamplesPerSec:=SampleRate;
 po1.nAvgBytesPerSec:=BytesPerSecond;
 po1.nBlockAlign:=channels*(resolution div 8);
 po1.wBitsPerSample:=Resolution;
 po1.cbSize:=0;

 waveOutOpen(@z1,WAVE_MAPPER,@po1,cardinal(@waveOutProc),0,CALLBACK_FUNCTION);

 fillmemory(@po21,sizeof(po21),0);
 po21.lpData:=@data1[0];
 po21.dwBufferLength:=DataBytes;
 po21.dwBytesRecorded:=0;
 po21.dwUser:=0;
 po21.dwFlags:=WHDR_BEGINLOOP;
 po21.dwLoops:=0;

 fillmemory(@po22,sizeof(po22),0);
 po22.lpData:=@data2[0];
 po22.dwBufferLength:=DataBytes;
 po22.dwBytesRecorded:=0;
 po22.dwUser:=0;
 po22.dwFlags:=WHDR_BEGINLOOP;
 po22.dwLoops:=0;

 waveOutPrepareHeader(z1,@po21,sizeof(po21));
 waveOutPrepareHeader(z1,@po22,sizeof(po22));

 INIReg:=TregIniFile.Create;
 Form1.Top:=INIReg.ReadInteger('SOFTWARE\Tonometer\Options','FormTop',100);
 Form1.Left:=INIReg.ReadInteger('SOFTWARE\Tonometer\Options','FormLeft',150);
 TrackBar1.Position:=INIReg.ReadInteger('SOFTWARE\Tonometer\Options','Volume',50);
 RadioGroup1.ItemIndex:=INIReg.ReadInteger('SOFTWARE\Tonometer\Options','Note',9);
 RadioGroup2.ItemIndex:=INIReg.ReadInteger('SOFTWARE\Tonometer\Options','Octave',4);
 RadioGroup3.ItemIndex:=INIReg.ReadInteger('SOFTWARE\Tonometer\Options','Language',1);
 INIReg.CloseKey;
 INIReg.Free;
 RadioGroup1Click(Self);
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 waveOutReset(z1);
 trig:=false;
 waveOutUnprepareHeader(z1,@po21,sizeof(po21));
 waveOutClose(z1);
 INIReg:=TregIniFile.Create;
 INIReg.WriteInteger('SOFTWARE\Tonometer\Options','FormTop',Form1.Top);
 INIReg.WriteInteger('SOFTWARE\Tonometer\Options','FormLeft',Form1.Left);
 INIReg.WriteInteger('SOFTWARE\Tonometer\Options','Volume',TrackBar1.Position);
 INIReg.WriteInteger('SOFTWARE\Tonometer\Options','Note',RadioGroup1.ItemIndex);
 INIReg.WriteInteger('SOFTWARE\Tonometer\Options','Octave',RadioGroup2.ItemIndex);
 INIReg.WriteInteger('SOFTWARE\Tonometer\Options','Language',RadioGroup3.ItemIndex);
 INIReg.CloseKey;
 INIReg.Free;
end;

procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
 F:=440*Power(Power(2,1/12),(radiogroup1.ItemIndex-9))*power(2,radiogroup2.ItemIndex-4);
 DELTA:=2*pi*F/SampleRate;
 if RadioGroup3.ItemIndex=0 then
      label3.Caption:='Frequency = '+floattostr(F)+' Hz'
 else label3.Caption:=' = '+floattostr(F)+' ';
end;

procedure TForm1.WMNCHitTest(var M: TWMNCHitTest);
begin
 inherited; //   p
 if M.Result=htClient then//    ?
 M.Result:=htCaption; //   -   Windows ,    caption bar
end;

procedure TForm1.VolumeWndProc(var Msg: TMessage);
begin
 case Msg.Msg of
 WM_LBUTTONDOWN:begin
                Trackbar1.Position:=TrackBar1.Max*(msg.lParam shr 16 - 9) div 132;
                Application.ProcessMessages;
                end;
 end;
 VolumeOldWndProc(Msg);
end;

procedure TForm1.ApplicationEvents1Message(var Msg: tagMSG; var Handled: Boolean);
begin
 if (msg.hwnd<>button1.Handle) and (msg.message=wm_keyup) and (msg.wParam=32)then Button1Click(self);
end;

procedure TForm1.RadioGroup3Click(Sender: TObject);
begin
 case RadioGroup3.ItemIndex of
  0:begin
     label1.Caption:='Volume';
     label1.Left:=214;
     form1.Caption:='Tonometer';
     application.Title:=' Tonometer';
     RadioGroup1.Items.SetText('C'+#10+'C #'+#10+'D'+#10+'D #'+#10+'E'+#10+'F'+#10+
     'F #'+#10+'G'+#10+'G #'+#10+'A'+#10+'A #'+#10+'B');
     RadioGroup2.Items.SetText('0'+#10+'1'+#10+'2'+#10+'3'+#10+
     '4'+#10+'5'+#10+'6'+#10+'7'+#10+'8'+#10+'9');
     RadioGroup1.Caption:='Note';
     RadioGroup2.Caption:='Octave';
     if button1.Caption='' then button1.Caption:='Play';
     if button1.Caption=' !' then button1.Caption:='Stop !';
    end;
  1:begin
     label1.Caption:='';
     label1.Left:=205;
     form1.Caption:='';
     application.Title:=' ';
     RadioGroup1.Items.SetText(''+#10+' #'+#10+''+#10+' #'+#10+''+#10+''+#10+
     ' #'+#10+''+#10+' #'+#10+''+#10+' #'+#10+'');
     RadioGroup2.Items.SetText(''+#10+''+#10+''+#10+''+#10+
     ''+#10+''+#10+''+#10+''+#10+''+#10+'');
     RadioGroup1.Caption:='';
     RadioGroup2.Caption:='';
     if button1.Caption='Play' then button1.Caption:='';
     if button1.Caption='Stop !' then button1.Caption:=' !';     
    end;
 end;
 RadioGroup1Click(nil);
end;

end.
